Subject: Re: bug#28034: elixir build fails

From: Pjotr Prins <[email-masked]>
Date: Sun, 3 Dec 2017 06:43:50 +0100

On Sat, Dec 02, 2017 at 07:04:09PM +0100, nee wrote:
> Hello, what is the current state for the elixir package?
> 
> I saw this issue on elixir's github page:
> https://github.com/elixir-lang/elixir/issues/6586
> Has there been any progress since then? From what I understand the build
> fails because of impure test cases. Can we just disable these tests for
> now to make it build again?

I am all for that. Not that many tests fail (in the order of 1%), but it is a
pain to disable them by hand. That is why I have not done an update in a while
- I am running a more recent version on my GUIX_PACKAGE_PATH with tests
disabled.

The simple way is to remove a number of test files. The majority of
tests will work and since Erlang's tests also work - there are a large
number of them (thousands). I would be fully confident the new package is fine.

> I wanted to see if I can install and package the phoenix web-server
> framework and the pleroma federated social network, since both are
> becoming pretty popular recently due to their low resource requirements.

That would be really cool. I would like support for Elixir packages. I
run a REST service and GraphQL is coming. I don't like to depend on Elixir's
packaging system, though it has been reasonably OK so far. It will break at
some point - as they all do. Elixir's packaging is similar to D's dub, so we can
take some cues from that. Elixir packages everything in the local source tree -
similar to Ruby's bundler.

> I also think it's not good to have a broken package on master for so long.
> The hydra web interface shows that version 1.4.2 used to build in the
> past
> https://hydra.gnu.org/job/gnu/master/elixir-1.4.2.x86_64-linux/all?page=2
> and I only see one commit for this version in the past, so what did
> change there?

Must be a dependency that changed. Hmmm. August 2nd.

  commit ee217402f7bf4b9fd49250650cf94d882a5e1a23
  Author: Peter Mikkelsen <[email-masked]>
  Date:   Mon Jul 31 01:19:15 2017 +0200

      gnu: erlang: Update to 20.0.
      
      * gnu/packages/erlang.scm (erlang): Update to 20.0.
      
      Signed-off-by: Ludovic Courtès <[email-masked]>

Must be it ;). It is great people are updating Erlang! These are great
programming languages.

I am happy to work on Elixir with you.

Pj.
--